###### R posedm (Testy etnost)######

setwd("C:/Users/Navratil/Documents/R")
# setwd("C:/Users/uivatel/Documents/R") # cesta pro koln PC

####Ch-kvadrt test - jeden faktor####
# ch-kvadrt test se provd funkc chisq.test()

?chisq.test

# loha: Li se poet samc a samic pekroivch vodn tok pi obstarvn potravy? 
# Samc pekroilo vodn tok 7 a samic 13.
# H0: Nen rozdl v potu samc a samic, kter/ pekroily/i vodn tok;
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

pohlavi <- c(7, 13) #zadvm men hodnoty

chisq.test(pohlavi, p = c(0.5, 0.5)) #test oekvanho rovnomrnho rozdlen 

# atribut p stanov oekvan rozdlen a test testuje shodu dat s tmto rozdlenm

# Vsledek: X-squared = 1.8, df = 1, p-value = 0.1797
# H0 nemohu zamtnout, rozdl na hladin vznamnosti alfa=95% neexistuje (p je vt ne 0.05).


####Ch-kvadrt test - dva faktory####
# nejprve nahrajeme data

library(readxl)

data <- read_excel("C:/Users/Navratil/Documents/Navratil/ZF/Statistika/glm_glz_1.xlsx")
# data <- read_excel("E:/R/glm_glz_1.xlsx") # cesta k datm na Vaich flekch

# loha: Li se zastoupen potu pr podle spnosti podle toho v jakm porostu si 
# postavil hnzdo?
# H0: nen rozdl v etnostech hnzd v typu porostu mezi typy spnosti pr;
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

# Nejprve musm vytvoit kontingenn tabulku, kter se tvo pkazem table() a atributy 
# udvaj z jakch faktor se m tabulka vytvoit.

ctab <- table(data$typ, data$porost)
ctab

# no a nsledn ji budme testovat

chisq.test(ctab)

# vsledek: X-squared = 23.813, df = 6, p-value = 0.0005652
#   Warning message:
#   In chisq.test(ctab) : Chi-squared approximation may be incorrect
# Vsledek testu je tedy vysoce prkazn, ale jsou porueny pedpoklady pouit testu - 
# vce ne 20% hodnot je mench ne 5, musme sluovat podobn porosty (podobn jsou 
# 1 s 2 a 3 s 4), ili nov kategorie 1 bude sluovat etnosti porostu 1 a 2 a 
# nov kategorie 2 bude sluovat etnosti v podobnch porostech 3 a 4

ctab2 <- cbind(ctab[,"1"] + ctab[,"2"], ctab[,"3"] + ctab[,"4"])
ctab2

# provedeme test na upravench datech

chisq.test(ctab2)

# vsledek: X-squared = 11.11, df = 2, p-value = 0.003868
# H0 zamtm, rozdl na hladin vznamnosti alfa=95% existuje (p je men ne 0.05).



####Fisherv exaktn test####

# Zadn lohy je identick jako v pedchozm ppad, testujeme tabulku ctab
# H0: nen rozdl v etnostech hnzd v typu porostu mezi typy spnosti pr;
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

# Fisherv exaktn test pro vliv dvou faktor se provn funkc fisher.test()
?fisher.test

fisher.test(ctab)

# vsledek: p-value = 0.0005793 ; alternative hypothesis: two.sided
# H0 zamtm, rozdl na hladin vznamnosti alfa=95% existuje (p je men ne 0.05).



####Kolmogorov-Smirnov test####

# Li se poet lokalit podle vegetanch jednotek od rovnomrho zastoupen jednotek
# v krajin? Zazanmnali jsme v prvnm typu 3 loklaity, ve druhm 7 lokalit a ve tetm 11 lokalit.

# H0: poetnost lokalit v typech vegetace je rovnomrn;
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

# data:
obs <- c(3,7,11)
exp <- c(7,7,7)

# test pomoc pkazu ks.test()
?ks.test

ks.test(obs,exp)

# vsledek: D = 0.33333, p-value = 0.9963 ; alternative hypothesis: two-sided
# warning message mete v tomto ppad ignorovat
# H0 nemohu zamtnout, rozdl na hladin vznamnosti alfa=95% neexistuje (p je vt ne 0.05).


####Vizualizace etnost####


###Kolov graf###
# Klasick kolov grafy se tvo pkazem pie()
?pie

# Vytvome kolov graf pro zystoupen typ vegetace z pkladu K-S testu

pie(obs, labels=c("vegetace 1", "vegetace 2", "vegetace 3"), main = "Zastoupen vegetanch typ", init.angle=90, col=gray(seq(from=0, to=1, length=3)), clockwise = T)

# Atributy - labesl tvo popisky, main vlo nzev, init.angle ud poten 
# hel pro zobrazovn, col zadv barvu, clockwise True zajist poad podle 
# hodinovch ruiek.

# Ovldn barev:
pie(obs, col=c("yellow", "blue", "red")) # vybran barvy
pie(obs, col=rainbow(3,start=0.1,end=0.5)) # barvy duhy s nastavenm potku a konce vbru barev
pie(obs, col=terrain.colors(3)) # paleta "tern"

# Legenda: 
# je j teba pidat pkazem legend()
legend("topright", legend=c("vegetace 1", "vegetace 2", "vegetace 3"), fill=terrain.colors(3))

# prvn atribut je umstn, pak je, co m obsahovat a nsledn se definuj barvy, monost prav
# je velmi mnoho 
?legend

###Mozaikov graf###
# mozaikov graf se tro pkazem mosaicplot()

?mosaicplot

# Vytvome mozaikov graf pro podly typ pr v typech vegetace z pkladu o hnzdech vodnch ptk

mosaicplot(ctab, shade = T, cex = .9, main = "Typy hnzd ve vegetaci")

# Atributy - shade True zajist vybarven hlavnch diferenc, cex je atribut ovldajc relativn 
# velikost psma v grafu.
# Vynikajc je, e pkaz mosaicplot() lze pout i na pole (Array), tedy vcerozmrnou matici.